; GRAPHIC TEST
; (C) 2002-2005, Andreas Berg. All Rights Reserved.

; MACRO: PutPixel x,y,color
putPixel  macro x, y, color
  mov  ax,0a000h
  mov  es,ax
  mov  ax,y
  mov  dx,320
  mul  dx
  add  ax,x
  mov  di,ax
  mov  al,color
  stosb
endm

; Set up COM file
.model   tiny
.com
.code
.org     100h

; Init segment registers
push     cs
pop      ds

; Save current video mode
mov      ah,0fh
int      10h
mov      [oldScr],al

; Set graphic mode
mov      ah,0
mov      al,13h
int      10h

; Put some pixels
putPixel 0,0,15
putPixel 1,1,14
putPixel 2,2,13
putPixel 3,3,12

putPixel 10,10,7
putPixel 11,10,8
putPixel 12,10,7
putPixel 13,10,8
putPixel 14,10,7
putPixel 15,10,8
putPixel 10,12,7
putPixel 11,12,8
putPixel 12,12,7
putPixel 13,12,8
putPixel 14,12,7
putPixel 15,12,8
putPixel 10,11,8
putPixel 15,11,7

; Wait for keypress
xor      ax,ax
int      16h

; Restore screen
mov      ah,0
mov      al,[oldScr]
int      10h

; Terminate COM file
int      20h

; Data
oldScr  db   0

end
